Subject: Re: [PATCH] fix i2c on PPC linkstation / kurobox machines

From: Benjamin Herrenschmidt <[email-masked]>
Date: Fri, 24 Oct 2008 11:19:40 +1100

On Fri, 2008-10-24 at 01:05 +0200, Guennadi Liakhovetski wrote:
> i2c is broken on linkstation / kurobox machines since at least 2.6.27. Fix 
> it. Also remove CONFIG_SERIAL_OF_PLATFORM, which, if enabled, breaks the 
> serial console after the "console handover: boot [udbg0] -> real [ttyS1]" 
> message.
> 
> Signed-off-by: Guennadi Liakhovetski <[email-masked]>

You may want to use udbg_printf() to track down what's up. There's some
fishy code there indeed, what happens is that the legacy serial code
creates a platform device at boot time. Then, the of_serial attaches to
the device node for the same device and tries to register it. It's
supposed to "detect" that it's the same device but yeah, it may be
buggy, I've seen problems with it in the past, among others, I think it
can lose some state.

In the meantime, removing SERIAL_OF_PLATFORM is a good solution.

Ben.